<?php
class validation
{
	public function set_rules($field, $label = '', $rules = '')
	{
		$error = array();
		if(is_array($field))
		{
			foreach($field as $value)
			{
				//form get or post field
				$form_field		 	= 		$value['field'];
				//label
				$form_label 		= 		$value['label'];
				//all rules
				$form_rules 		= 		$value['rules'];
				$form_email			=		$value['email'];
				$form_min_length	= 		$value['min_length'];
				$form_max_length	=		$value['max_length'];
				$form_matches		=		$value['matches'];
				$form_alpha_numeric	=		$value['alpha_numeric'];
				$form_numeric		=		$value['numeric'];
				$form_integer		=		$value['integer'];
				$form_decimal		=		$value['decimal'];
				
				if($form_rules == 'need')
				{
					if($this->required($form_field) == false)
					{
						$error[] = "The {$form_label} field is required";	
					}
				}
				
				if($form_email == 'valid')
				{
					if($this->valid_emails($form_field) == false)
					{
						$error[] = "The {$form_label} field must contain a valid email address";
					}
				}
				
				if($form_min_length == true)
				{
					if($this->min_length($form_field, $form_min_length) == false)
					{
						$error[] = "The {$form_label} minimum length {$form_min_length} character.";
					}
				}
				
				if($form_max_length == true)
				{
					if($this->max_length($form_field, $form_max_length) == false)
					{
						$error[] = "The {$form_label} maximum length {$form_max_length} character.";
					}
				}
				
				if($form_matches == true)
				{
					if($this->matches($form_matches, $form_field) == false)
					{
						$error[] = "The {$form_label} field does not match the Password field.";
					}
				}
				
				if($form_alpha_numeric == true)
				{
					if($this->alpha_numeric($form_field) == false)
					{
						$error[] = "The {$form_label} field must be alpha numeric.";
					}
				}
				
				if($form_numeric == true)
				{
					if($this->numeric($form_field) == false)
					{
						$error[] = "The {$form_label} field must be numeric.";
					}
				}
				
				if($form_integer == true)
				{
					if($this->integer($form_field) == false)
					{
						$error[] = "The {$form_label} field must be integer.";
					}
				}
				
				if($form_decimal == true)
				{
					if($this->decimal($form_field) == false)
					{
						$error[] = "The {$form_label} field must be decimal.";
					}
				}
			}
		}
		else
		{
			$rules_exploed = explode('|',$rules);
			for($x = 0; $x < count($rules_exploed); $x++)
			{
				$final_rules = $rules_exploed[$x];
				$rules_exploed2 = explode('[', $final_rules);
				
				
				if($final_rules == 'need')
				{
					if($this->required($field) == false)
					{
						$error[] = "The {$label} field is required.";	
					}
				}
				
				if($final_rules == 'valid')
				{
					if($this->valid_emails($field) == false)
					{
						$error[] = "The {$label} field must contain a valid email address.";
					}
				}
				
				if($final_rules == 'integer')
				{
					if($this->integer($field) == false)
					{
						$error[] = "The {$label} field must be integer.";
					}
				}
				
				if($final_rules == 'alpha_numeric')
				{
					if($this->alpha_numeric($field) == false)
					{
						$error[] = "The {$label} field must be alpha numeric.";
					}
				}
				
				if($final_rules == 'decimal')
				{
					if($this->decimal($field) == false)
					{
						$error[] = "The {$label} field must be decimal.";
					}
				}
				
				if($final_rules == 'numeric')
				{
					if($this->numeric($field) == false)
					{
						$error[] = "The {$label} field must be numeric.";
					}
				}
				
				if($rules_exploed2[0] == 'min_length')
				{
					$minlimit = str_ireplace(']', "", $rules_exploed2[1]);
					if($this->min_length($field, $minlimit) == false)
					{
						$error[] = "The {$form_label} minimum length {$minlimit} character.";
					}
				}
				
				if($rules_exploed2[0] == 'max_length')
				{
					$maxlimit = str_ireplace(']', "", $rules_exploed2[1]);
					if($this->max_length($field, $maxlimit) == false)
					{
						$error[] = "The {$form_label} maximum length {$maxlimit} character.";
					}
				}
			}
		}
		
		if(count($error) > 0)
		{
			foreach($error as $v)
			{
				//echo "<li>".$v."</li>";
                $this->GetMessage($v,'error');	
			}
			return false;
		}
		else
		{
			return true;	
		}
	}
	
	private function required($str)
    {
        if ( ! is_array($str))
        {
            return (trim($str) == '') ? FALSE : TRUE;
        }
        else
        {
            return ( ! empty($str));
        }
    }
	
	private function matches($str, $field)
    {
		if(($str != $field))
		return false;
		else
		return true;
    }
	
	private function min_length($str, $val)
    {
        if (preg_match("/[^0-9]/", $val))
        {
            return FALSE;
        }

        if (function_exists('mb_strlen'))
        {
            return (mb_strlen($str) < $val) ? FALSE : TRUE;
        }

        return (strlen($str) < $val) ? FALSE : TRUE;
    }
	
	private function max_length($str, $val)
    {
        if (preg_match("/[^0-9]/", $val))
        {
            return FALSE;
        }

        if (function_exists('mb_strlen'))
        {
            return (mb_strlen($str) > $val) ? FALSE : TRUE;
        }

        return (strlen($str) > $val) ? FALSE : TRUE;
    }
	
	private function valid_email($str)
    {
        return ( ! preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $str)) ? FALSE : TRUE;
    }
	
	private function valid_emails($str)
    {
        if (strpos($str, ',') === FALSE)
        {
            return $this->valid_email(trim($str));
        }

        foreach (explode(',', $str) as $email)
        {
            if (trim($email) != '' && $this->valid_email(trim($email)) === FALSE)
            {
                return FALSE;
            }
        }
        return TRUE;
    }
	
	private function alpha_numeric($str)
    {
        return ( ! preg_match("/^([a-z0-9])+$/i", $str)) ? FALSE : TRUE;
    }
	
	private function numeric($str)
    {
        return (bool)preg_match( '/^[\-+]?[0-9]*\.?[0-9]+$/', $str);

    }
	
	private function integer($str)
    {
        return (bool) preg_match('/^[\-+]?[0-9]+$/', $str);
    }
	
	private function decimal($str)
    {
        return (bool) preg_match('/^[\-+]?[0-9]+\.[0-9]+$/', $str);
    }
    public function GetMessage($msg, $cat)
    {
        if($cat == 'warning')
        {
            $type = 'alert-block';
        }
        elseif($cat == 'success')
        {
            $type = 'alert-success';
        }
        elseif($cat == 'error')
        {
            $type = 'alert-error';
        }
        ?>
            <div class="alert <?=$type?>">
                <button type="button" class="close" data-dismiss="alert"></button>
                    <?=$msg?>
            </div>
        <?php
    }
}

//=============how to use?
/*$config = array(
               array(
                     'field'   => $_GET['Name'],
                     'label'   => 'Name',
                     'rules'   => 'need'
                  ),
			   array(
                     'field'   	=> $_GET['Email'],
                     'label'   	=> 'E-Mail',
                     'rules'   	=> 'need',
					 'email'	=>	'valid'
                  ),
			   array(
                     'field'   			=> $_GET['Phone'],
                     'label'   			=> 'Phone number',
					 'integer'			=>	TRUE,
					 'min_length'		=>	'11'
                  ),
               array(
                     'field'   			=> 	$_GET['UserName'],
                     'label'   			=> 	'User Name',
                     'rules'   			=> 	'need',
					 'min_length'		=>	'6',
					 'max_length'		=>	'16',
					 'alpha_numeric'	=> 	TRUE
                  ),
               array(
                     'field'   		=> $_GET['PassWord'],
                     'label'   		=> 'Password',
                     'rules'   		=> 'need',
					 'min_length'	=>	'6',
					 'max_length'	=>	'10'
                  ),   
               array(
                     'field'   	=> $_GET['conPassWord'],
                     'label'   	=> 'Confirmation Password',
                     'rules'   	=> 'need',
					 'matches'	=>	$_GET['PassWord']
                  ),
			  array(
                     'field'   => $_GET['condition'],
                     'label'   => 'Trams & Condition',
                     'rules'   => 'need'
                  )
            );
			
if($_REQUEST['IsSubmit'])
{	
	////$data = $validation->set_rules($config); use-1
	$data = $validation->set_rules($_GET['Name'], 'Full Name', 'need');
	$data = $validation->set_rules($_GET['Email'], 'E-Mail', 'need|valid');
	$data = $validation->set_rules($_GET['UserName'], 'Username', 'need|min_length[5]|max_length[12]');
	$data = $validation->set_rules($_GET['Phone'], 'Mobile number', 'need|decimal');
}*/
?>